﻿Friend Class clsHalDB

#Region " Private Variables "

    Private SqlConnection As New System.Data.SqlClient.SqlConnection
    Private SqlCommand As New System.Data.SqlClient.SqlCommand
    Private ServerName As String = "HAL"
    Private DatabaseName As String = "BTI_MatSafe"
    Private UserName As String = "sa"
    Private PassWord As String = "NoPasswordHere"

#End Region

#Region " Private Subs & Functions "

    Private Sub MakeSQLConn(ByVal ServerName As String, ByVal DatabaseName As String, ByVal Username As String, ByVal Password As String)

        Dim MyConnectionString As String = "data source=" & ServerName & ";initial catalog=" & DatabaseName & ";persist security info=False;user id=" & Username & ";password=" & Password & ";workstation id=SPACEGHOST;packet size=4096"
        SqlConnection.ConnectionString = MyConnectionString
        SqlCommand.Connection = SqlConnection

    End Sub

    Private Sub AddUpDateDatabase(ByVal SQL_Command As String)

        ' executes the nonquery SQL_Command

        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        Dim UpdateCommand As New System.Data.SqlClient.SqlCommand(SQL_Command, SqlConnection)
        UpdateCommand.Connection.Open()
        UpdateCommand.ExecuteNonQuery()
        UpdateCommand.Connection.Close()
        SqlCommand.Connection.Close()

    End Sub

    Private Function GetTotalQuantity(ByVal SerialNumber As String) As Integer

        Dim TempQty As Integer = 0
        Dim TempSQL As String = "SELECT Quantity FROM Material WHERE SerialNumber = '" & SerialNumber & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempQty = UserRecord("Quantity")
        Loop
        SqlConnection.Close()
        Return TempQty

    End Function

    Private Function GetCheckInQuantity(ByVal SerialNumber As String) As Integer

        Dim TempQty As Integer = 0
        Dim TempSQL As String = "SELECT SUM(Quantity) As Total FROM CheckIn WHERE SerialNumber = '" & SerialNumber & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempQty = UserRecord("Total")
        Loop
        SqlConnection.Close()
        Return TempQty

    End Function

    Private Function GetCheckOutQuantity(ByVal SerialNumber As String) As Integer

        Dim TempQty As Integer = 0
        Dim TempSQL As String = "SELECT SUM(Quantity) As Total FROM CheckOut WHERE SerialNumber = '" & SerialNumber & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempQty = UserRecord("Total")
        Loop
        SqlConnection.Close()
        Return TempQty

    End Function

    Private Function GetLoginID(ByVal OpRFID As String) As String

        Dim TempID As String = ""
        Dim TempSQL As String = "SELECT LoginID FROM Login WHERE RFID = '" & OpRFID & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempID = UserRecord("LoginID")
        Loop
        SqlConnection.Close()
        Return TempID

    End Function

#End Region

#Region " Public Subs & Functions "

    Public Function VerifyLogin(ByVal RFID As String) As String

        Dim TempLogin As String = ""
        Dim TempSQL As String = "SELECT Username FROM Login WHERE RFID = '" & RFID & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            TempLogin = UserRecord("Username")
        Loop
        SqlConnection.Close()
        If TempLogin = "" Then TempLogin = "NONE"
        Return TempLogin

    End Function

    Public Sub AddCheckIn(ByVal CheckInData As clsTcp.CheckIn)

        Dim SQL_Command As String = "INSERT INTO CheckIn (UserName, SerialNumber, Quantity, Location, CheckInTime) VALUES ('" & GetLoginID(CheckInData.OpRFID) & "', '" & _
                                    CheckInData.SerialNumber & "', " & CheckInData.Quantity & ", '" & CheckInData.Location & "', '" & _
                                    Format(Now, "MM/dd/yyy hh:mm:ss") & "') ;"
        AddUpDateDatabase(SQL_Command)

    End Sub

    Public Sub AddCheckOut(ByVal CheckOutData As clsTcp.CheckOut)

        Dim EmployeeProcessor As New clsTimeClock
        Dim EmployeeID As String = EmployeeProcessor.GetEmployeeID(CheckOutData.Employee)
        Dim SQL_Command As String = "INSERT INTO CheckOut (UserName, EmployeeName, SerialNumber, Quantity, Location, CheckOutTime) VALUES ('" & GetLoginID(CheckOutData.OpRFID) & "', '" & _
                                    EmployeeID & "', '" & CheckOutData.SerialNumber & "', " & CheckOutData.Quantity & ", '" & CheckOutData.Location & "', '" & _
                                    Format(Now, "MM/dd/yyy hh:mm:ss") & "') ;"
        AddUpDateDatabase(SQL_Command)

    End Sub

    Public Overloads Function JobMaterialMatch(ByVal CheckInData As clsTcp.CheckIn) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(SerialNumber) AS Total FROM Material WHERE ( SerialNumber = '" & CheckInData.SerialNumber & "' AND " & _
                                "Job = '" & CheckInData.Job & "' ) ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then TempBool = True
        Return TempBool

    End Function

    Public Overloads Function JobMaterialMatch(ByVal CheckOutData As clsTcp.CheckOut) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(SerialNumber) AS Total FROM Material WHERE ( SerialNumber = '" & CheckOutData.SerialNumber & "' AND " & _
                                "Job = '" & CheckOutData.Job & "' ) ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then TempBool = True
        Return TempBool

    End Function

    Public Overloads Function JobMaterialMatch(ByVal ClockInData As clsTcp.ClockIn) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(SerialNumber) AS Total FROM Material WHERE ( SerialNumber = '" & ClockInData.SerialNumber & "' AND " & _
                                "Job = '" & ClockInData.Job & "' ) ;"
        If ClockInData.SerialNumber = "N/A" Then
            TempBool = True
        Else
            MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
            SqlConnection.Open()
            SqlCommand.Connection = SqlConnection
            SqlCommand.CommandText = TempSQL
            Dim UserRecord As System.Data.SqlClient.SqlDataReader
            UserRecord = SqlCommand.ExecuteReader
            Do While UserRecord.Read
                On Error Resume Next
                Count = UserRecord("Total")
            Loop
            SqlConnection.Close()
            If Count = 1 Then TempBool = True
        End If
        Return TempBool

    End Function

    Public Function JobClassA(ByVal Job As String) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(Job) AS Total FROM Material WHERE Job = '" & Job & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count > 0 Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Function QuantityMatch(ByVal CheckInData As clsTcp.CheckIn) As Boolean

        Dim TempBool As Boolean = False
        Dim TotalQuantity As Integer = GetTotalQuantity(CheckInData.SerialNumber)
        Dim CheckInQuantity As Integer = GetCheckInQuantity(CheckInData.SerialNumber)
        If TotalQuantity - CheckInQuantity >= Val(CheckInData.Quantity) Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Function QuantityCheck(ByVal CheckOutData As clsTcp.CheckOut) As Boolean

        Dim TempBool As Boolean = False
        Dim TotalQuantity As Integer = GetCheckInQuantity(CheckOutData.SerialNumber)
        Dim CheckInQuantity As Integer = GetCheckOutQuantity(CheckOutData.SerialNumber)
        If TotalQuantity - CheckInQuantity >= Val(CheckOutData.Quantity) Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Overloads Function LocationMatch(ByVal CheckInData As clsTcp.CheckIn) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT Count(Location) As Total FROM Location WHERE Location = '" & CheckInData.Location & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Overloads Function LocationMatch(ByVal CheckOutData As clsTcp.CheckOut) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT Count(Location) As Total FROM Location WHERE Location = '" & CheckOutData.Location & "' ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then
            TempBool = True
        Else
            TempBool = False
        End If
        Return TempBool

    End Function

    Public Function MaterialLocMatch(ByVal CheckOutData As clsTcp.CheckOut) As Boolean

        Dim TempBool As Boolean = False
        Dim Count As Integer = 0
        Dim TempSQL As String = "SELECT COUNT(SerialNumber) AS Total FROM CheckIn WHERE ( SerialNumber = '" & CheckOutData.SerialNumber & "' AND " & _
                                "Location = '" & CheckOutData.Location & "' ) ;"
        MakeSQLConn(ServerName, DatabaseName, UserName, PassWord)
        SqlConnection.Open()
        SqlCommand.Connection = SqlConnection
        SqlCommand.CommandText = TempSQL
        Dim UserRecord As System.Data.SqlClient.SqlDataReader
        UserRecord = SqlCommand.ExecuteReader
        Do While UserRecord.Read
            On Error Resume Next
            Count = UserRecord("Total")
        Loop
        SqlConnection.Close()
        If Count = 1 Then TempBool = True
        Return TempBool

    End Function

#End Region

End Class
