﻿Imports System.Net.Sockets
Imports System.Text

Friend Class clsTcp

#Region " Private Variables "

    Dim TcpServer As TcpListener
    Dim TcpThread As System.Threading.Thread
    Dim EventLogRecorder As New clsEventLog

#End Region

#Region " Public Structures & Constants "

    Public Structure CheckIn
        Dim OpRFID As String
        Dim SerialNumber As String
        Dim Job As String
        Dim Quantity As String
        Dim Location As String
    End Structure

    Public Structure CheckOut
        Dim OpRFID As String
        Dim SerialNumber As String
        Dim Job As String
        Dim Quantity As String
        Dim Location As String
        Dim Employee As String
    End Structure

    Public Structure ClockIn
        Dim Employee As String
        Dim Job As String
        Dim JobOp As String
        Dim SerialNumber As String
        Dim Machine As String
    End Structure

    Public Structure ClockOut
        Dim Employee As String
        Dim Job As String
        Dim JobOp As String
        Dim Quantity As String
        Dim Scrap As String
    End Structure

    Const btiOpRFID = 0
    Const btiSerialNumber = 1
    Const btiJob = 2
    Const btiQuantity = 3
    Const btiLocation = 4
    Const btiEmployee = 5

    Const btiClockInEmployee = 0
    Const btiClockInJob = 1
    Const btiClockInJobOp = 2
    Const btiClockInSerialNumber = 3
    Const btiClockInMachine = 4

    Const btiClockOutEmployee = 0
    Const btiClockOutJob = 1
    Const btiClockOutJobOp = 2
    Const btiClockOutQuantity = 3
    Const btiClockOutScrap = 4

#End Region

#Region " Private Subs & Functions "

#Region " Login Subs & Functions "

    Private Function ProcessLogin(ByVal Data As String) As String

        Dim HalDB As New clsHalDB
        Dim RFID As String = Data.Substring(2, 10)
        Dim TempString As String = ""
        Dim User As String = HalDB.VerifyLogin(RFID)
        If User = "NONE" Then
            TempString = "<l1/>"
        Else
            TempString = "<l" & User & "/>"
        End If
        Return TempString

    End Function

#End Region

#Region " Check In Subs & Functions "

    Private Function ProcessCheckIn(ByVal Data As String) As String

        Dim TempResponse As String = "<i3/>"
        Dim MyCheckIn As CheckIn = ParseCheckIn(Data)
        Dim CheckInProcessor As New clsHalDB
        Try
            If MyCheckIn.OpRFID = "Error" Then
                TempResponse = "<i3/>"
            Else
                If CheckInProcessor.JobMaterialMatch(MyCheckIn) Then
                    If CheckInProcessor.QuantityMatch(MyCheckIn) Then
                        If CheckInProcessor.LocationMatch(MyCheckIn) Then
                            CheckInProcessor.AddCheckIn(MyCheckIn)
                            TempResponse = "<i0/>"
                        Else
                            TempResponse = "<i5/>"
                        End If
                    Else
                        TempResponse = "<i4/>"
                    End If
                Else
                    TempResponse = "<i2/>"
                End If
            End If
        Catch ex As Exception
            EventLogRecorder.WriteToEventLog("ProcessCheckIn:" & vbCrLf & ex.Message & vbCrLf & "Operator: " & MyCheckIn.OpRFID & _
                                 vbCrLf & "S/N: " & MyCheckIn.SerialNumber & vbCrLf & "Job: " & MyCheckIn.Job & _
                                 vbCrLf & "Qty: " & MyCheckIn.Quantity & vbCrLf & "Location: " & MyCheckIn.Location & _
                                 vbCrLf, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempResponse = "<i3/>"
        End Try
        Return TempResponse

    End Function

    Private Function ParseCheckIn(ByVal Data As String) As CheckIn

        Dim TempCheckIn As New CheckIn
        Dim CleanLine As String = Data.Substring(3, Data.Length - 7)
        Dim DataArray() As String = Split(CleanLine, "_")
        If UBound(DataArray) = 4 Then
            TempCheckIn.OpRFID = DataArray(btiOpRFID)
            TempCheckIn.SerialNumber = DataArray(btiSerialNumber)
            TempCheckIn.Job = DataArray(btiJob)
            TempCheckIn.Quantity = DataArray(btiQuantity)
            TempCheckIn.Location = Format(Val(DataArray(btiLocation)), "000")
        Else
            EventLogRecorder.WriteToEventLog("ParseCheckIn:" & vbCrLf & Data, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempCheckIn.OpRFID = "Error"
        End If
        Return TempCheckIn

    End Function

#End Region

#Region " Check Out Subs & Functions "

    Private Function ProcessCheckOut(ByVal Data As String) As String

        Dim TempResponse As String = "<o3/>"
        Dim MyCheckOut As CheckOut = ParseCheckOut(Data)
        Dim CheckOutProcessor As New clsHalDB
        Try
            If MyCheckOut.OpRFID = "Error" Then
                TempResponse = "<o3/>"
            Else
                If CheckOutProcessor.JobMaterialMatch(MyCheckOut) Then
                    If CheckOutProcessor.QuantityCheck(MyCheckOut) Then
                        If CheckOutProcessor.LocationMatch(MyCheckOut) Then
                            If CheckOutProcessor.MaterialLocMatch(MyCheckOut) Then
                                CheckOutProcessor.AddCheckOut(MyCheckOut)
                                TempResponse = "<o0/>"
                            Else
                                TempResponse = "<o6/>"
                            End If
                        Else
                            TempResponse = "<o5/>"
                        End If
                    Else
                        TempResponse = "<o4/>"
                    End If
                Else
                    TempResponse = "<o2/>"
                End If
            End If
        Catch ex As Exception
            EventLogRecorder.WriteToEventLog("ProcessCheckOut:" & vbCrLf & ex.Message & vbCrLf & "Operator: " & MyCheckOut.OpRFID & _
                                             vbCrLf & "S/N: " & MyCheckOut.SerialNumber & vbCrLf & "Job: " & MyCheckOut.Job & _
                                             vbCrLf & "Qty: " & MyCheckOut.Quantity & vbCrLf & "Location: " & MyCheckOut.Location & _
                                             vbCrLf & "Employee: " & MyCheckOut.Employee, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempResponse = "<o3/>"
        End Try
        Return TempResponse

    End Function

    Private Function ParseCheckOut(ByVal Data As String) As CheckOut

        Dim TempCheckOut As New CheckOut
        Dim CleanLine As String = Data.Substring(3, Data.Length - 7)
        Dim DataArray() As String = Split(CleanLine, "_")
        If UBound(DataArray) = 5 Then
            TempCheckOut.OpRFID = DataArray(btiOpRFID)
            TempCheckOut.SerialNumber = DataArray(btiSerialNumber)
            TempCheckOut.Job = DataArray(btiJob)
            TempCheckOut.Quantity = DataArray(btiQuantity)
            TempCheckOut.Location = Format(Val(DataArray(btiLocation)), "000")
            TempCheckOut.Employee = DataArray(btiEmployee)
        Else
            EventLogRecorder.WriteToEventLog("ParseCheckOut:" & vbCrLf & Data, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempCheckOut.OpRFID = "Error"
        End If
        Return TempCheckOut

    End Function

#End Region

#Region " Verify Subs & Functions "

    Private Function ProcessVerify(ByVal Data As String) As String

        Dim HalDB As New clsHalDB
        Dim Job As String = Data.Substring(3, Data.Length - 7)
        Dim Tempstring As String = ""
        If HalDB.JobClassA(Job) Then
            Tempstring = "<vA/>"
        Else
            Tempstring = "<vO/>"
        End If
        Return TempString

    End Function

#End Region

#Region " Clock In Subs & Functions "

    Private Function ProcessClockIn(ByVal Data As String) As String

        Dim TempResponse As String = "<s2/>"
        Dim MyClockIn As ClockIn = ParseClockIn(Data)
        Dim ClockInProcessor As New clsDataCollectionsDB
        Dim TimeClockDb As New clsTimeClock
        Dim MaterialDB As New clsHalDB
        Dim JobBoss As New clsJobBossDB
        Try
            If TimeClockDb.EmployeeExists(MyClockIn.Employee) Then
                If MaterialDB.JobMaterialMatch(MyClockIn) Then
                    If JobBoss.IsClosed(MyClockIn.Job) = False Then
                        If MyClockIn.Employee = "ERROR" Then
                            TempResponse = "<s5/>"
                        Else
                            If ClockInProcessor.ClockInIsOK(MyClockIn) Then
                                ClockInProcessor.AddClockIn(MyClockIn)
                                TempResponse = "<s0/>"
                            Else
                                TempResponse = "<s2/>"
                            End If
                        End If
                    Else
                        TempResponse = "<s4/>"
                    End If
                Else
                    TempResponse = "<s1/>"
                End If
            Else
                TempResponse = "<s3/>"
            End If
        Catch ex As Exception
            EventLogRecorder.WriteToEventLog("ProcessClockIn:" & vbCrLf & ex.Message & vbCrLf, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempResponse = "<s2/>"
        End Try
        Return TempResponse

    End Function

    Private Function ParseClockIn(ByVal Data As String) As ClockIn

        Dim TempClockIn As New ClockIn
        Dim CleanLine As String = Data.Substring(3, Data.Length - 7)
        Dim DataArray() As String = Split(CleanLine, "_")
        Dim TimeClockDB As New clsTimeClock
        If UBound(DataArray) = 4 Then
            TempClockIn.Employee = TimeClockDB.GetEmployeeID(DataArray(btiClockInEmployee))
            TempClockIn.Job = DataArray(btiClockInJob)
            TempClockIn.JobOp = DataArray(btiClockInJobOp)
            TempClockIn.SerialNumber = DataArray(btiClockInSerialNumber)
            TempClockIn.Machine = DataArray(btiClockInMachine)
        Else
            EventLogRecorder.WriteToEventLog("ParseClockIn:" & vbCrLf & Data, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempClockIn.Employee = "ERROR"
        End If
        Return TempClockIn

    End Function

#End Region

#Region " Clock Out Subs & Functions "

    Private Function ProcessClockOut(ByVal Data As String) As String

        Dim TempResponse As String = "<e2/>"
        Dim MyClockOut As ClockOut = ParseClockOut(Data)
        Dim ClockInProcessor As New clsDataCollectionsDB
        Dim TimeClockDb As New clsTimeClock
        Dim JobBoss As New clsJobBossDB
        Try
            If TimeClockDb.EmployeeExists(MyClockOut.Employee) Then
                If JobBoss.IsClosed(MyClockOut.Job) = False Then
                    If MyClockOut.Employee = "ERROR" Then
                        TempResponse = "<e5/>"
                    Else
                        If ClockInProcessor.ClockOutIsOK(MyClockOut) Then
                            ClockInProcessor.AddClockOut(MyClockOut)
                            TempResponse = "<e0/>"
                        Else
                            TempResponse = "<e2/>"
                        End If
                    End If
                Else
                    TempResponse = "<e4/>"
                End If
            Else
                TempResponse = "<e3/>"
            End If
        Catch ex As Exception
            EventLogRecorder.WriteToEventLog("ProcessClockOut:" & vbCrLf & ex.Message & vbCrLf, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempResponse = "<e2/>"
        End Try
        Return TempResponse

    End Function

    Private Function ParseClockOut(ByVal Data As String) As ClockOut

        Dim TempClockOut As New ClockOut
        Dim CleanLine As String = Data.Substring(3, Data.Length - 7)
        Dim DataArray() As String = Split(CleanLine, "_")
        Dim TimeClockDB As New clsTimeClock
        If UBound(DataArray) = 4 Then
            TempClockOut.Employee = TimeClockDB.GetEmployeeID(DataArray(btiClockOutEmployee))
            TempClockOut.Job = DataArray(btiClockOutJob)
            TempClockOut.JobOp = DataArray(btiClockOutJobOp)
            TempClockOut.Quantity = DataArray(btiClockOutQuantity)
            TempClockOut.Scrap = DataArray(btiClockOutScrap)
        Else
            EventLogRecorder.WriteToEventLog("ParseClockOut:" & vbCrLf & Data, "BTI_MatSafeServer", EventLogEntryType.Error, "Application")
            TempClockOut.Employee = "ERROR"
        End If
        Return TempClockOut
    End Function

#End Region

    Private Function CleanData(ByVal Data As String) As String

        Dim TempString As String = Data.TrimEnd(System.Convert.ToChar(0))
        Return TempString

    End Function

    Private Sub PortListen()

        Dim RemoteComputer As System.Net.Sockets.TcpClient
        Dim DataStream As NetworkStream
        Dim InBytes() As Byte
        Dim Message As String
        Dim OutBytes As [Byte]()
        Do
            RemoteComputer = TcpServer.AcceptTcpClient
            DataStream = RemoteComputer.GetStream()
            ReDim InBytes(RemoteComputer.ReceiveBufferSize)
            DataStream.Read(InBytes, 0, RemoteComputer.ReceiveBufferSize)
            Message = Encoding.ASCII.GetString(InBytes)
            Message = CleanData(Message)
            Select Case Message.Substring(1, 1)
                Case "L"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessLogin(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
                Case "I"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessCheckIn(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
                Case "O"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessCheckOut(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
                Case "V"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessVerify(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
                Case "S"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessClockIn(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
                Case "E"
                    OutBytes = Encoding.ASCII.GetBytes(ProcessClockOut(Message))
                    DataStream.Write(OutBytes, 0, OutBytes.Length)
            End Select
            RemoteComputer.Close()
        Loop

    End Sub

#End Region

#Region " Public Subs & Functions "

    Public Sub TcpStart()

        TcpServer = New System.Net.Sockets.TcpListener(System.Net.IPAddress.Any, 2011)
        TcpServer.Start()
        TcpThread = New System.Threading.Thread(AddressOf PortListen)
        TcpThread.IsBackground = True
        TcpThread.Start()
        EventLogRecorder.WriteToEventLog("Server started.", "BTI_MatSafeServer", EventLogEntryType.Information, "Application")

    End Sub

    Public Sub TcpStop()

        TcpThread.Abort()
        TcpServer.Stop()
        EventLogRecorder.WriteToEventLog("Server stopped.", "BTI_MatSafeServer", EventLogEntryType.Information, "Application")

    End Sub

#End Region

End Class
